org.hsqldb.jdbc

## Class JDBCCallableStatement

- java.lang.Object
- - org.hsqldb.jdbc.JDBCPreparedStatement
  - - org.hsqldb.jdbc.JDBCCallableStatement

- All Implemented Interfaces:
    java.lang.AutoCloseable, java.sql.CallableStatement, java.sql.PreparedStatement, java.sql.Statement, java.sql.Wrapper

      public class JDBCCallableStatement
      extends JDBCPreparedStatement
      implements java.sql.CallableStatement

  The interface used to execute SQL stored procedures. The JDBC API provides a stored procedure SQL escape syntax that allows stored procedures to be called in a standard way for all RDBMSs. This escape syntax has one form that includes a result parameter and one that does not. If used, the result parameter must be registered as an OUT parameter. The other parameters can be used for input, output or both. Parameters are referred to sequentially, by number, with the first parameter being 1.

  (JDBC4 clarification:)

         {?= call <procedure-name>[(<arg1>,<arg2>, ...)]}
         {call <procedure-name>[(<arg1>,<arg2>, ...)]}

  IN parameter values are set using the `set` methods inherited from `PreparedStatement`. The type of all OUT parameters must be registered prior to executing the stored procedure; their values are retrieved after execution via the `get` methods provided here.

  A `CallableStatement` can return one `ResultSet` object or multiple `ResultSet` objects. Multiple `ResultSet` objects are handled using operations inherited from `Statement`.

  For maximum portability, a call's `ResultSet` objects and update counts should be processed prior to getting the values of output parameters.

  ### HSQLDB-Specific Information:

  Beyond the XOpen/ODBC extended scalar functions, stored procedures are typically supported in ways that vary greatly from one DBMS implementation to the next. So, it is almost guaranteed that the code for a stored procedure written under a specific DBMS product will not work without at least some modification in the context of another vendor's product or even across a single vendor's product lines. Moving stored procedures from one DBMS product line to another almost invariably involves complex porting issues and often may not be possible at all. Be warned.

  One kind of HSQLDB stored procedures and functions is SQL/JRT, Java routines that map directly onto the static methods of compiled Java classes found on the class path of the engine at runtime. The CREATE PROCEDURE or CREATE FUNCTION statements are used in SQL to support the Java methods.

  The other kind of HSQLDB stored procedures is SQL/PSM routines that are written entirely in the SQL procedural language. Overloaded methods are supported and resolved according to the type of parameters. With procedures, `OUT` and `IN OUT` parameters are also supported.

  In addition, HSQLDB stored procedure call mechanism allows the more general HSQLDB SQL expression evaluation mechanism. This extension provides the ability to evaluate simple SQL expressions, possibly containing Java method invocations.

  With HSQLDB, executing a `CALL` statement that produces an opaque (OTHER) or known scalar object reference has virtually the same effect as:

       CREATE TABLE DUAL (dummy VARCHAR);
       INSERT INTO DUAL VALUES(NULL);
       SELECT <simple-expression> FROM DUAL;

  HSQLDB functions can return a single result set. HSQLDB procedures can return one or more result sets. Here is a very simple example of an HSQLDB stored procedure generating a user-defined result set:

       package mypackage;

       import java.sql.ResultSet;
       import java.sql.SQLException;

       class MyLibraryClass {

            public static ResultSet mySp() throws SQLException {
                return ctx.getConnection().createStatement().executeQuery("select * from my_table");
            }
       }

  (campbell-burnet@users)
  Since:
    1.9.0
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)
  See Also:
    `JDBCConnection.prepareCall(java.lang.String)`, `JDBCResultSet`

- - ### Field Summary

    - ### Fields inherited from interface java.sql.Statement

      `CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JDBCCallableStatement(JDBCConnection c, java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Constructs a new JDBCCallableStatement with the specified connection and result type.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Does the specialized work required to free this object's resources and that of it's parent classes.
    `void` | `closeOnCompletion()` Specifies that this `Statement` will be closed when all its dependent result sets are closed.
    `java.sql.ResultSet` | `executeQuery()` Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.
    `java.sql.Array` | `getArray(int parameterIndex)` Retrieves the value of the designated JDBC `ARRAY` parameter as an `Array` object in the Java programming language.
    `java.sql.Array` | `getArray(java.lang.String parameterName)` Retrieves the value of a JDBC `ARRAY` parameter as an `Array` object in the Java programming language.
    `java.math.BigDecimal` | `getBigDecimal(int parameterIndex)` Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.
    `java.math.BigDecimal` | `getBigDecimal(int parameterIndex, int scale)` Deprecated. use `getBigDecimal(int parameterIndex)` or `getBigDecimal(String parameterName)`
    `java.math.BigDecimal` | `getBigDecimal(java.lang.String parameterName)` Retrieves the value of a JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.
    `java.sql.Blob` | `getBlob(int parameterIndex)` Retrieves the value of the designated JDBC `BLOB` parameter as a `Blob` object in the Java programming language.
    `java.sql.Blob` | `getBlob(java.lang.String parameterName)` Retrieves the value of a JDBC `BLOB` parameter as a `Blob` object in the Java programming language.
    `boolean` | `getBoolean(int parameterIndex)` (JDBC4 modified:) Retrieves the value of the designated JDBC `BIT` or `BOOLEAN` parameter as a `boolean` in the Java programming language.
    `boolean` | `getBoolean(java.lang.String parameterName)` (JDBC4 modified:)
    `byte` | `getByte(int parameterIndex)` Retrieves the value of the designated JDBC `TINYINT` parameter as a `byte` in the Java programming language.
    `byte` | `getByte(java.lang.String parameterName)` Retrieves the value of a JDBC `TINYINT` parameter as a `byte` in the Java programming language.
    `byte[]` | `getBytes(int parameterIndex)` Retrieves the value of the designated JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.
    `byte[]` | `getBytes(java.lang.String parameterName)` Retrieves the value of a JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.
    `java.io.Reader` | `getCharacterStream(int parameterIndex)` Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language.
    `java.io.Reader` | `getCharacterStream(java.lang.String parameterName)` Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language.
    `java.sql.Clob` | `getClob(int parameterIndex)` Retrieves the value of the designated JDBC `CLOB` parameter as a `java.sql.Clob` object in the Java programming language.
    `java.sql.Clob` | `getClob(java.lang.String parameterName)` Retrieves the value of a JDBC `CLOB` parameter as a `Clob` object in the Java programming language.
    `java.sql.Date` | `getDate(int parameterIndex)` Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object.
    `java.sql.Date` | `getDate(int parameterIndex, java.util.Calendar cal)` Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date.
    `java.sql.Date` | `getDate(java.lang.String parameterName)` Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object.
    `java.sql.Date` | `getDate(java.lang.String parameterName, java.util.Calendar cal)` Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date.
    `double` | `getDouble(int parameterIndex)` Retrieves the value of the designated JDBC `DOUBLE` parameter as a `double` in the Java programming language.
    `double` | `getDouble(java.lang.String parameterName)` Retrieves the value of a JDBC `DOUBLE` parameter as a `double` in the Java programming language.
    `float` | `getFloat(int parameterIndex)` Retrieves the value of the designated JDBC `FLOAT` parameter as a `float` in the Java programming language.
    `float` | `getFloat(java.lang.String parameterName)` Retrieves the value of a JDBC `FLOAT` parameter as a `float` in the Java programming language.
    `int` | `getInt(int parameterIndex)` Retrieves the value of the designated JDBC `INTEGER` parameter as an `int` in the Java programming language.
    `int` | `getInt(java.lang.String parameterName)` Retrieves the value of a JDBC `INTEGER` parameter as an `int` in the Java programming language.
    `long` | `getLong(int parameterIndex)` Retrieves the value of the designated JDBC `BIGINT` parameter as a `long` in the Java programming language.
    `long` | `getLong(java.lang.String parameterName)` Retrieves the value of a JDBC `BIGINT` parameter as a `long` in the Java programming language.
    `java.io.Reader` | `getNCharacterStream(int parameterIndex)` Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language.
    `java.io.Reader` | `getNCharacterStream(java.lang.String parameterName)` Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language.
    `java.sql.NClob` | `getNClob(int parameterIndex)` Retrieves the value of the designated JDBC `NCLOB` parameter as a `java.sql.NClob` object in the Java programming language.
    `java.sql.NClob` | `getNClob(java.lang.String parameterName)` Retrieves the value of a JDBC `NCLOB` parameter as a `java.sql.NClob` object in the Java programming language.
    `java.lang.String` | `getNString(int parameterIndex)` Retrieves the value of the designated `NCHAR`, `NVARCHAR` or `LONGNVARCHAR` parameter as a `String` in the Java programming language.
    `java.lang.String` | `getNString(java.lang.String parameterName)` Retrieves the value of the designated `NCHAR`, `NVARCHAR` or `LONGNVARCHAR` parameter as a `String` in the Java programming language.
    `java.lang.Object` | `getObject(int parameterIndex)` Retrieves the value of the designated parameter as an `Object` in the Java programming language.
    `<T> T` | `getObject(int parameterIndex, java.lang.Class<T> type)` Returns an object representing the value of OUT parameter `parameterIndex` and will convert from the SQL type of the parameter to the requested Java data type, if the conversion is supported.
    `java.lang.Object` | `getObject(int parameterIndex, java.util.Map<java.lang.String,java.lang.Class<?>> map)` Returns an object representing the value of OUT parameter `parameterIndex` and uses `map` for the custom mapping of the parameter value.
    `java.lang.Object` | `getObject(java.lang.String parameterName)` Retrieves the value of a parameter as an `Object` in the Java programming language.
    `<T> T` | `getObject(java.lang.String parameterName, java.lang.Class<T> type)` Returns an object representing the value of OUT parameter `parameterName` and will convert from the SQL type of the parameter to the requested Java data type, if the conversion is supported.
    `java.lang.Object` | `getObject(java.lang.String parameterName, java.util.Map<java.lang.String,java.lang.Class<?>> map)` Returns an object representing the value of OUT parameter `parameterName` and uses `map` for the custom mapping of the parameter value.
    `java.sql.Ref` | `getRef(int parameterIndex)` Retrieves the value of the designated JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.
    `java.sql.Ref` | `getRef(java.lang.String parameterName)` Retrieves the value of a JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.
    `java.sql.ResultSet` | `getResultSet()` Retrieves the current result as a `ResultSet` object.
    `java.sql.RowId` | `getRowId(int parameterIndex)` Retrieves the value of the designated JDBC `ROWID` parameter as a `java.sql.RowId` object.
    `java.sql.RowId` | `getRowId(java.lang.String parameterName)` Retrieves the value of the designated JDBC `ROWID` parameter as a `java.sql.RowId` object.
    `short` | `getShort(int parameterIndex)` Retrieves the value of the designated JDBC `SMALLINT` parameter as a `short` in the Java programming language.
    `short` | `getShort(java.lang.String parameterName)` Retrieves the value of a JDBC `SMALLINT` parameter as a `short` in the Java programming language.
    `java.sql.SQLXML` | `getSQLXML(int parameterIndex)` Retrieves the value of the designated `SQL XML` parameter as a `java.sql.SQLXML` object in the Java programming language.
    `java.sql.SQLXML` | `getSQLXML(java.lang.String parameterName)` Retrieves the value of the designated `SQL XML` parameter as a `java.sql.SQLXML` object in the Java programming language.
    `java.lang.String` | `getString(int parameterIndex)` Retrieves the value of the designated JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.
    `java.lang.String` | `getString(java.lang.String parameterName)` Retrieves the value of a JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.
    `java.sql.Time` | `getTime(int parameterIndex)` Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object.
    `java.sql.Time` | `getTime(int parameterIndex, java.util.Calendar cal)` Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time.
    `java.sql.Time` | `getTime(java.lang.String parameterName)` Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object.
    `java.sql.Time` | `getTime(java.lang.String parameterName, java.util.Calendar cal)` Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time.
    `java.sql.Timestamp` | `getTimestamp(int parameterIndex)` Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.
    `java.sql.Timestamp` | `getTimestamp(int parameterIndex, java.util.Calendar cal)` Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object.
    `java.sql.Timestamp` | `getTimestamp(java.lang.String parameterName)` Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.
    `java.sql.Timestamp` | `getTimestamp(java.lang.String parameterName, java.util.Calendar cal)` Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object.
    `java.net.URL` | `getURL(int parameterIndex)` Retrieves the value of the designated JDBC `DATALINK` parameter as a `java.net.URL` object.
    `java.net.URL` | `getURL(java.lang.String parameterName)` Retrieves the value of a JDBC `DATALINK` parameter as a `java.net.URL` object.
    `boolean` | `isCloseOnCompletion()` Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
    `void` | `registerOutParameter(int parameterIndex, int sqlType)` Registers the OUT parameter in ordinal position `parameterIndex` to the JDBC type `sqlType`.
    `void` | `registerOutParameter(int parameterIndex, int sqlType, int scale)` Registers the parameter in ordinal position `parameterIndex` to be of JDBC type `sqlType`.
    `void` | `registerOutParameter(int parameterIndex, int sqlType, java.lang.String typeName)` Registers the designated output parameter.
    `void` | `registerOutParameter(java.lang.String parameterName, int sqlType)` Registers the OUT parameter named `parameterName` to the JDBC type `sqlType`.
    `void` | `registerOutParameter(java.lang.String parameterName, int sqlType, int scale)` Registers the parameter named `parameterName` to be of JDBC type `sqlType`.
    `void` | `registerOutParameter(java.lang.String parameterName, int sqlType, java.lang.String typeName)` Registers the designated output parameter.
    `void` | `setAsciiStream(java.lang.String parameterName, java.io.InputStream x)` Sets the designated parameter to the given input stream.
    `void` | `setAsciiStream(java.lang.String parameterName, java.io.InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setAsciiStream(java.lang.String parameterName, java.io.InputStream x, long length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setBigDecimal(java.lang.String parameterName, java.math.BigDecimal x)` Sets the designated parameter to the given `java.math.BigDecimal` value.
    `void` | `setBinaryStream(java.lang.String parameterName, java.io.InputStream x)` Sets the designated parameter to the given input stream.
    `void` | `setBinaryStream(java.lang.String parameterName, java.io.InputStream x, int length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setBinaryStream(java.lang.String parameterName, java.io.InputStream x, long length)` Sets the designated parameter to the given input stream, which will have the specified number of bytes.
    `void` | `setBlob(java.lang.String parameterName, java.sql.Blob x)` Sets the designated parameter to the given `java.sql.Blob` object.
    `void` | `setBlob(java.lang.String parameterName, java.io.InputStream inputStream)` Sets the designated parameter to a `InputStream` object.
    `void` | `setBlob(java.lang.String parameterName, java.io.InputStream inputStream, long length)` Sets the designated parameter to a `InputStream` object.
    `void` | `setBoolean(java.lang.String parameterName, boolean x)` Sets the designated parameter to the given Java `boolean` value.
    `void` | `setByte(java.lang.String parameterName, byte x)` Sets the designated parameter to the given Java `byte` value.
    `void` | `setBytes(java.lang.String parameterName, byte[] x)` Sets the designated parameter to the given Java array of bytes.
    `void` | `setCharacterStream(java.lang.String parameterName, java.io.Reader reader)` Sets the designated parameter to the given `Reader` object.
    `void` | `setCharacterStream(java.lang.String parameterName, java.io.Reader reader, int length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
    `void` | `setCharacterStream(java.lang.String parameterName, java.io.Reader reader, long length)` Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
    `void` | `setClob(java.lang.String parameterName, java.sql.Clob x)` Sets the designated parameter to the given `java.sql.Clob` object.
    `void` | `setClob(java.lang.String parameterName, java.io.Reader reader)` Sets the designated parameter to a `Reader` object.
    `void` | `setClob(java.lang.String parameterName, java.io.Reader reader, long length)` Sets the designated parameter to a `Reader` object.
    `void` | `setDate(java.lang.String parameterName, java.sql.Date x)` Sets the designated parameter to the given `java.sql.Date` value (JDBC4 clarification:)
    `void` | `setDate(java.lang.String parameterName, java.sql.Date x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
    `void` | `setDouble(java.lang.String parameterName, double x)` Sets the designated parameter to the given Java `double` value.
    `void` | `setFloat(java.lang.String parameterName, float x)` Sets the designated parameter to the given Java `float` value.
    `void` | `setInt(java.lang.String parameterName, int x)` Sets the designated parameter to the given Java `int` value.
    `void` | `setLong(java.lang.String parameterName, long x)` Sets the designated parameter to the given Java `long` value.
    `void` | `setNCharacterStream(java.lang.String parameterName, java.io.Reader value)` Sets the designated parameter to a `Reader` object.
    `void` | `setNCharacterStream(java.lang.String parameterName, java.io.Reader value, long length)` Sets the designated parameter to a `Reader` object.
    `void` | `setNClob(java.lang.String parameterName, java.sql.NClob value)` Sets the designated parameter to a `java.sql.NClob` object.
    `void` | `setNClob(java.lang.String parameterName, java.io.Reader reader)` Sets the designated parameter to a `Reader` object.
    `void` | `setNClob(java.lang.String parameterName, java.io.Reader reader, long length)` Sets the designated parameter to a `Reader` object.
    `void` | `setNString(java.lang.String parameterName, java.lang.String value)` Sets the designated parameter to the given `String` object.
    `void` | `setNull(java.lang.String parameterName, int sqlType)` Sets the designated parameter to SQL `NULL`.
    `void` | `setNull(java.lang.String parameterName, int sqlType, java.lang.String typeName)` Sets the designated parameter to SQL `NULL`.
    `void` | `setObject(java.lang.String parameterName, java.lang.Object x)` Sets the value of the designated parameter with the given object.
    `void` | `setObject(java.lang.String parameterName, java.lang.Object x, int targetSqlType)` Sets the value of the designated parameter with the given object.
    `void` | `setObject(java.lang.String parameterName, java.lang.Object x, int targetSqlType, int scale)` Sets the value of the designated parameter with the given object.
    `void` | `setRowId(java.lang.String parameterName, java.sql.RowId x)` Sets the designated parameter to the given `java.sql.RowId` object.
    `void` | `setShort(java.lang.String parameterName, short x)` Sets the designated parameter to the given Java `short` value.
    `void` | `setSQLXML(java.lang.String parameterName, java.sql.SQLXML xmlObject)` Sets the designated parameter to the given `java.sql.SQLXML` object.
    `void` | `setString(java.lang.String parameterName, java.lang.String x)` Sets the designated parameter to the given Java `String` value.
    `void` | `setTime(java.lang.String parameterName, java.sql.Time x)` Sets the designated parameter to the given `java.sql.Time` value.
    `void` | `setTime(java.lang.String parameterName, java.sql.Time x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
    `void` | `setTimestamp(java.lang.String parameterName, java.sql.Timestamp x)` Sets the designated parameter to the given `java.sql.Timestamp` value.
    `void` | `setTimestamp(java.lang.String parameterName, java.sql.Timestamp x, java.util.Calendar cal)` Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
    `void` | `setURL(java.lang.String parameterName, java.net.URL val)` Sets the designated parameter to the given `java.net.URL` object.
    `boolean` | `wasNull()` Retrieves whether the last OUT parameter read had the value of SQL `NULL`.

    - ### Methods inherited from class org.hsqldb.jdbc.JDBCPreparedStatement

      `addBatch, addBatch, cancel, clearBatch, clearParameters, clearWarnings, execute, execute, execute, execute, execute, executeBatch, executeLargeUpdate, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getMaxFieldSize, getMaxRows, getMetaData, getMoreResults, getMoreResults, getParameterMetaData, getQueryTimeout, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isPoolable, isWrapperFor, setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setCursorName, setDate, setDate, setDouble, setEscapeProcessing, setFetchDirection, setFetchSize, setFloat, setInt, setLong, setMaxFieldSize, setMaxRows, setNCharacterStream, setNCharacterStream, setNClob, setNClob, setNClob, setNString, setNull, setNull, setObject, setObject, setObject, setPoolable, setQueryTimeout, setRef, setRowId, setShort, setSQLXML, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL, toString, unwrap`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.sql.CallableStatement

      `registerOutParameter, registerOutParameter, registerOutParameter, registerOutParameter, registerOutParameter, registerOutParameter, setObject, setObject`

    - ### Methods inherited from interface java.sql.PreparedStatement

      `addBatch, clearParameters, execute, executeLargeUpdate, executeUpdate, getMetaData, getParameterMetaData, setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNCharacterStream, setNCharacterStream, setNClob, setNClob, setNClob, setNString, setNull, setNull, setObject, setObject, setObject, setObject, setObject, setRef, setRowId, setShort, setSQLXML, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL`

    - ### Methods inherited from interface java.sql.Statement

      `addBatch, cancel, clearBatch, clearWarnings, execute, execute, execute, execute, executeBatch, executeLargeBatch, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isPoolable, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

    - ### Methods inherited from interface java.sql.Wrapper

      `isWrapperFor, unwrap`

- - ### Constructor Detail

    - #### JDBCCallableStatement

          public JDBCCallableStatement(JDBCConnection c,
                                       java.lang.String sql,
                                       int resultSetType,
                                       int resultSetConcurrency,
                                       int resultSetHoldability)
                                throws org.hsqldb.HsqlException,
                                       java.sql.SQLException

      Constructs a new JDBCCallableStatement with the specified connection and result type.
      Parameters:
        `c` - the connection on which this statement will execute
        `sql` - the SQL statement this object represents
        `resultSetType` - the type of result this statement will produce
        `resultSetConcurrency` - (updatability)
        `resultSetHoldability` - (validity beyond commit)
      Throws:
        `org.hsqldb.HsqlException` - if the statement is not accepted by the database
        `java.sql.SQLException` - if preprocessing by driver fails

  - ### Method Detail

    - #### registerOutParameter

          public void registerOutParameter(int parameterIndex,
                                           int sqlType)
                                    throws java.sql.SQLException

      Registers the OUT parameter in ordinal position `parameterIndex` to the JDBC type `sqlType`. All OUT parameters must be registered before a stored procedure is executed.

      The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

      If the JDBC type expected to be returned to this output parameter is specific to this particular database, `sqlType` should be `java.sql.Types.OTHER`. The method `getObject(int)` retrieves the value.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature. This method can be called after a PrepareCall method. HSQLDB has already determined which parameters are OUT or INOUT parameters, therefore this method only checks and throws an exception if the parameter is not of the correct form. The data type argument is ignored

      The `get` method to read the value of the parameter is determined by the engine based on the data type of the parameter. Furthermore, HSQLDB supports multiple OUT and INOUT parameters for stored procedures.

      Specified by:
        `registerOutParameter` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `sqlType` - the JDBC type code defined by `java.sql.Types`. If the parameter is of JDBC type `NUMERIC` or `DECIMAL`, the version of `registerOutParameter` that accepts a scale value should be used.
      Throws:
        `java.sql.SQLException` - JDBC 4.1 [if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
      See Also:
        `Types`

    - #### getResultSet

          public java.sql.ResultSet getResultSet()
                                          throws java.sql.SQLException

      Description copied from class: `JDBCPreparedStatement`
      Retrieves the current result as a `ResultSet` object. This method should be called only once per result.

      ### HSQLDB-Specific Information:

      Without an interceding call to executeXXX, each invocation of this method will produce a new, initialized ResultSet instance referring to the current result, if any.

      Specified by:
        `getResultSet` in interface `java.sql.Statement`
      Overrides:
        `getResultSet` in class `JDBCPreparedStatement`
      Returns:
        the current result as a `ResultSet` object or `null` if the result is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      See Also:
        `JDBCPreparedStatement.execute()`

    - #### registerOutParameter

          public void registerOutParameter(int parameterIndex,
                                           int sqlType,
                                           int scale)
                                    throws java.sql.SQLException

      Registers the parameter in ordinal position `parameterIndex` to be of JDBC type `sqlType`. (JDBC4 clarification:) All OUT parameters must be registered before a stored procedure is executed.

      The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

      This version of `registerOutParameter` should be used when the parameter is of JDBC type `NUMERIC` or `DECIMAL`.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `registerOutParameter` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `sqlType` - the SQL type code defined by `java.sql.Types`.
        `scale` - the desired number of digits to the right of the decimal point. It must be greater than or equal to zero.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
      See Also:
        `Types`

    - #### wasNull

          public boolean wasNull()
                          throws java.sql.SQLException

      Retrieves whether the last OUT parameter read had the value of SQL `NULL`. Note that this method should be called only after calling a getter method; otherwise, there is no value to use in determining whether it is `null` or not.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `wasNull` in interface `java.sql.CallableStatement`
      Returns:
        `true` if the last parameter read was SQL `NULL`; `false` otherwise
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `CallableStatement`

    - #### getString

          public java.lang.String getString(int parameterIndex)
                                     throws java.sql.SQLException

      Retrieves the value of the designated JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.

      For the fixed-length type JDBC `CHAR`, the `String` object returned has exactly the same value the (JDBC4 clarification:) SQL `CHAR` value had in the database, including any padding added by the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getString` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setString(java.lang.String, java.lang.String)`

    - #### getBoolean

          public boolean getBoolean(int parameterIndex)
                             throws java.sql.SQLException

      (JDBC4 modified:) Retrieves the value of the designated JDBC `BIT` or `BOOLEAN` parameter as a `boolean` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBoolean` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `false`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setBoolean(java.lang.String, boolean)`

    - #### getByte

          public byte getByte(int parameterIndex)
                       throws java.sql.SQLException

      Retrieves the value of the designated JDBC `TINYINT` parameter as a `byte` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getByte` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setByte(java.lang.String, byte)`

    - #### getShort

          public short getShort(int parameterIndex)
                         throws java.sql.SQLException

      Retrieves the value of the designated JDBC `SMALLINT` parameter as a `short` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getShort` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setShort(java.lang.String, short)`

    - #### getInt

          public int getInt(int parameterIndex)
                     throws java.sql.SQLException

      Retrieves the value of the designated JDBC `INTEGER` parameter as an `int` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getInt` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setInt(java.lang.String, int)`

    - #### getLong

          public long getLong(int parameterIndex)
                       throws java.sql.SQLException

      Retrieves the value of the designated JDBC `BIGINT` parameter as a `long` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getLong` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setLong(java.lang.String, long)`

    - #### getFloat

          public float getFloat(int parameterIndex)
                         throws java.sql.SQLException

      Retrieves the value of the designated JDBC `FLOAT` parameter as a `float` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getFloat` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setFloat(java.lang.String, float)`

    - #### getDouble

          public double getDouble(int parameterIndex)
                           throws java.sql.SQLException

      Retrieves the value of the designated JDBC `DOUBLE` parameter as a `double` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getDouble` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setDouble(java.lang.String, double)`

    - #### getBigDecimal

          public java.math.BigDecimal getBigDecimal(int parameterIndex,
                                                    int scale)
                                             throws java.sql.SQLException

      Deprecated. use `getBigDecimal(int parameterIndex)` or `getBigDecimal(String parameterName)`
      Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with scale digits to the right of the decimal point.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBigDecimal` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `scale` - the number of digits to the right of the decimal point
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      See Also:
        `setBigDecimal(java.lang.String, java.math.BigDecimal)`

    - #### getBytes

          public byte[] getBytes(int parameterIndex)
                          throws java.sql.SQLException

      Retrieves the value of the designated JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBytes` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setBytes(java.lang.String, byte[])`

    - #### getDate

          public java.sql.Date getDate(int parameterIndex)
                                throws java.sql.SQLException

      Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getDate` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setDate(java.lang.String, java.sql.Date)`

    - #### getTime

          public java.sql.Time getTime(int parameterIndex)
                                throws java.sql.SQLException

      Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTime` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setTime(java.lang.String, java.sql.Time)`

    - #### getTimestamp

          public java.sql.Timestamp getTimestamp(int parameterIndex)
                                          throws java.sql.SQLException

      Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTimestamp` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `setTimestamp(java.lang.String, java.sql.Timestamp)`

    - #### getObject

          public java.lang.Object getObject(int parameterIndex)
                                     throws java.sql.SQLException

      Retrieves the value of the designated parameter as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`.

      This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        A `java.lang.Object` holding the OUT parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      See Also:
        `Types`, `setObject(java.lang.String, java.lang.Object, int, int)`

    - #### getBigDecimal

          public java.math.BigDecimal getBigDecimal(int parameterIndex)
                                             throws java.sql.SQLException

      Retrieves the value of the designated JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBigDecimal` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value in full precision. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      Since:
        JDK 1.2
      See Also:
        `setBigDecimal(java.lang.String, java.math.BigDecimal)`

    - #### getObject

          public java.lang.Object getObject(int parameterIndex,
                                            java.util.Map<java.lang.String,java.lang.Class<?>> map)
                                     throws java.sql.SQLException

      Returns an object representing the value of OUT parameter `parameterIndex` and uses `map` for the custom mapping of the parameter value.

      This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `map` - the mapping from SQL type names to Java classes
      Returns:
        a `java.lang.Object` holding the OUT parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2
      See Also:
        `setObject(java.lang.String, java.lang.Object, int, int)`

    - #### getRef

          public java.sql.Ref getRef(int parameterIndex)
                              throws java.sql.SQLException

      Retrieves the value of the designated JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getRef` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value as a `Ref` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### getBlob

          public java.sql.Blob getBlob(int parameterIndex)
                                throws java.sql.SQLException

      Retrieves the value of the designated JDBC `BLOB` parameter as a `Blob` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBlob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value as a `Blob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### getClob

          public java.sql.Clob getClob(int parameterIndex)
                                throws java.sql.SQLException

      Retrieves the value of the designated JDBC `CLOB` parameter as a `java.sql.Clob` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value as a `Clob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### getArray

          public java.sql.Array getArray(int parameterIndex)
                                  throws java.sql.SQLException

      Retrieves the value of the designated JDBC `ARRAY` parameter as an `Array` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getArray` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value as an `Array` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.2

    - #### getDate

          public java.sql.Date getDate(int parameterIndex,
                                       java.util.Calendar cal)
                                throws java.sql.SQLException

      Retrieves the value of the designated JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getDate` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `cal` - the `Calendar` object the driver will use to construct the date
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      Since:
        JDK 1.2
      See Also:
        `setDate(java.lang.String, java.sql.Date)`

    - #### getTime

          public java.sql.Time getTime(int parameterIndex,
                                       java.util.Calendar cal)
                                throws java.sql.SQLException

      Retrieves the value of the designated JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTime` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `cal` - the `Calendar` object the driver will use to construct the time
      Returns:
        the parameter value; if the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      Since:
        JDK 1.2
      See Also:
        `setTime(java.lang.String, java.sql.Time)`

    - #### getTimestamp

          public java.sql.Timestamp getTimestamp(int parameterIndex,
                                                 java.util.Calendar cal)
                                          throws java.sql.SQLException

      Retrieves the value of the designated JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTimestamp` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `cal` - the `Calendar` object the driver will use to construct the timestamp
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      Since:
        JDK 1.2
      See Also:
        `setTimestamp(java.lang.String, java.sql.Timestamp)`

    - #### registerOutParameter

          public void registerOutParameter(int parameterIndex,
                                           int sqlType,
                                           java.lang.String typeName)
                                    throws java.sql.SQLException

      Registers the designated output parameter. This version of the method `registerOutParameter` should be used for a user-defined or `REF` output parameter. Examples of user-defined types include: `STRUCT`, `DISTINCT`, `JAVA_OBJECT`, and named array types.

      All OUT parameters must be registered before a stored procedure is executed.

      For a user-defined parameter, the fully-qualified SQL type name of the parameter should also be given, while a `REF` parameter requires that the fully-qualified type name of the referenced type be given. A JDBC driver that does not need the type code and type name information may ignore it. To be portable, however, applications should always provide these values for user-defined and `REF` parameters. Although it is intended for user-defined and `REF` parameters, this method may be used to register a parameter of any JDBC type. If the parameter does not have a user-defined or `REF` type, the typeName parameter is ignored.

      Note: When reading the value of an out parameter, you must use the getter method whose Java type corresponds to the parameter's registered SQL type.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `registerOutParameter` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2,...
        `sqlType` - a value from `Types`
        `typeName` - the fully-qualified name of an SQL structured type
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
      Since:
        JDK 1.2
      See Also:
        `Types`

    - #### registerOutParameter

          public void registerOutParameter(java.lang.String parameterName,
                                           int sqlType)
                                    throws java.sql.SQLException

      Registers the OUT parameter named `parameterName` to the JDBC type `sqlType`. All OUT parameters must be registered before a stored procedure is executed.

      The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

      If the JDBC type expected to be returned to this output parameter is specific to this particular database, `sqlType` should be `java.sql.Types.OTHER`. The method `getObject(int)` retrieves the value.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `registerOutParameter` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `sqlType` - the JDBC type code defined by `java.sql.Types`. If the parameter is of JDBC type `NUMERIC` or `DECIMAL`, the version of `registerOutParameter` that accepts a scale value should be used.
      Throws:
        `java.sql.SQLException` - JDBC 41.[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type or if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQL 1.7.0
      See Also:
        `Types`

    - #### registerOutParameter

          public void registerOutParameter(java.lang.String parameterName,
                                           int sqlType,
                                           int scale)
                                    throws java.sql.SQLException

      Registers the parameter named `parameterName` to be of JDBC type `sqlType`. (JDBC4 clarification:) All OUT parameters must be registered before a stored procedure is executed.

      The JDBC type specified by `sqlType` for an OUT parameter determines the Java type that must be used in the `get` method to read the value of that parameter.

      This version of `registerOutParameter` should be used when the parameter is of JDBC type `NUMERIC` or `DECIMAL`.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `registerOutParameter` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `sqlType` - SQL type code defined by `java.sql.Types`.
        `scale` - the desired number of digits to the right of the decimal point. It must be greater than or equal to zero.
      Throws:
        `java.sql.SQLException` - JDBC 41.[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type or if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `Types`

    - #### registerOutParameter

          public void registerOutParameter(java.lang.String parameterName,
                                           int sqlType,
                                           java.lang.String typeName)
                                    throws java.sql.SQLException

      Registers the designated output parameter. This version of the method `registerOutParameter` should be used for a user-named or REF output parameter. Examples of user-named types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

      (JDBC4 clarification:)

      All OUT parameters must be registered before a stored procedure is executed.

      For a user-named parameter the fully-qualified SQL type name of the parameter should also be given, while a REF parameter requires that the fully-qualified type name of the referenced type be given. A JDBC driver that does not need the type code and type name information may ignore it. To be portable, however, applications should always provide these values for user-named and REF parameters. Although it is intended for user-named and REF parameters, this method may be used to register a parameter of any JDBC type. If the parameter does not have a user-named or REF type, the typeName parameter is ignored.

      Note: When reading the value of an out parameter, you must use the `getXXX` method whose Java type XXX corresponds to the parameter's registered SQL type.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `registerOutParameter` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `sqlType` - a value from `Types`
        `typeName` - the fully-qualified name of an SQL structured type
      Throws:
        `java.sql.SQLException` - JDBC 41.[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type or if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQL 1.7.0
      See Also:
        `Types`

    - #### getURL

          public java.net.URL getURL(int parameterIndex)
                              throws java.sql.SQLException

      Retrieves the value of the designated JDBC `DATALINK` parameter as a `java.net.URL` object.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getURL` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2,...
      Returns:
        a `java.net.URL` object that represents the JDBC `DATALINK` value used as the designated parameter
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs, this method is called on a closed `CallableStatement`, or if the URL being returned is not a valid URL on the Java platform
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setURL(java.lang.String, java.net.URL)`

    - #### setURL

          public void setURL(java.lang.String parameterName,
                             java.net.URL val)
                      throws java.sql.SQLException

      Sets the designated parameter to the given `java.net.URL` object. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `setURL` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `val` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs, this method is called on a closed `CallableStatement`, or if a URL is malformed
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getURL(int)`

    - #### setNull

          public void setNull(java.lang.String parameterName,
                              int sqlType)
                       throws java.sql.SQLException

      Sets the designated parameter to SQL `NULL`.

      Note: You must specify the parameter's SQL type.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setNull` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `sqlType` - the SQL type code defined in `java.sql.Types`
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### setBoolean

          public void setBoolean(java.lang.String parameterName,
                                 boolean x)
                          throws java.sql.SQLException

      Sets the designated parameter to the given Java `boolean` value.

      (JDBC4 clarification:)

      The driver converts this to an SQL `BIT` or `BOOLEAN` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setBoolean` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getBoolean(int)`, `getBoolean(int)`

    - #### setByte

          public void setByte(java.lang.String parameterName,
                              byte x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setByte` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getByte(int)`

    - #### setShort

          public void setShort(java.lang.String parameterName,
                               short x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setShort` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getShort(int)`

    - #### setInt

          public void setInt(java.lang.String parameterName,
                             int x)
                      throws java.sql.SQLException

      Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setInt` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getInt(int)`

    - #### setLong

          public void setLong(java.lang.String parameterName,
                              long x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setLong` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getLong(int)`

    - #### setFloat

          public void setFloat(java.lang.String parameterName,
                               float x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `FLOAT` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setFloat` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getFloat(int)`

    - #### setDouble

          public void setDouble(java.lang.String parameterName,
                                double x)
                         throws java.sql.SQLException

      Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setDouble` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getDouble(int)`

    - #### setBigDecimal

          public void setBigDecimal(java.lang.String parameterName,
                                    java.math.BigDecimal x)
                             throws java.sql.SQLException

      Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setBigDecimal` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getBigDecimal(int, int)`

    - #### setString

          public void setString(java.lang.String parameterName,
                                java.lang.String x)
                         throws java.sql.SQLException

      Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setString` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getString(int)`

    - #### setBytes

          public void setBytes(java.lang.String parameterName,
                               byte[] x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setBytes` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getBytes(int)`

    - #### setDate

          public void setDate(java.lang.String parameterName,
                              java.sql.Date x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Date` value (JDBC4 clarification:)

      using the default time zone of the virtual machine that is running the application. The driver converts this to an SQL `DATE` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setDate` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getDate(int)`

    - #### setTime

          public void setTime(java.lang.String parameterName,
                              java.sql.Time x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setTime` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getTime(int)`

    - #### setTimestamp

          public void setTimestamp(java.lang.String parameterName,
                                   java.sql.Timestamp x)
                            throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setTimestamp` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getTimestamp(int)`

    - #### setAsciiStream

          public void setAsciiStream(java.lang.String parameterName,
                                     java.io.InputStream x,
                                     int length)
                              throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setAsciiStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the Java input stream that contains the ASCII parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### setBinaryStream

          public void setBinaryStream(java.lang.String parameterName,
                                      java.io.InputStream x,
                                      int length)
                               throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setBinaryStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the java input stream which contains the binary parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### setObject

          public void setObject(java.lang.String parameterName,
                                java.lang.Object x,
                                int targetSqlType,
                                int scale)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. The second argument must be an object type; for integral values, the `java.lang` equivalent objects should be used.

      The given Java object will be converted to the given targetSqlType before being sent to the database. If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

      Note that this method may be used to pass database- specific abstract data types.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the object containing the input parameter value
        `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
        `scale` - for java.sql.Types.DECIMAL or java.sql.Types.NUMERIC types, this is the number of digits after the decimal point. For all other types, this value will be ignored.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `targetSqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `Types`, `getObject(int)`

    - #### setObject

          public void setObject(java.lang.String parameterName,
                                java.lang.Object x,
                                int targetSqlType)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. This method is like the method `setObject` above, except that it assumes a scale of zero.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the object containing the input parameter value
        `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if `targetSqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getObject(int)`

    - #### setObject

          public void setObject(java.lang.String parameterName,
                                java.lang.Object x)
                         throws java.sql.SQLException

      Sets the value of the designated parameter with the given object. The second parameter must be of type `Object`; therefore, the `java.lang` equivalent objects should be used for built-in types.

      The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

      Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type. If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

      This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the object containing the input parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs, this method is called on a closed `CallableStatement` or if the given `Object` parameter is ambiguous
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getObject(int)`

    - #### setCharacterStream

          public void setCharacterStream(java.lang.String parameterName,
                                         java.io.Reader reader,
                                         int length)
                                  throws java.sql.SQLException

      Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `reader` - the `java.io.Reader` object that contains the UNICODE data used as the designated parameter
        `length` - the number of characters in the stream
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### setDate

          public void setDate(java.lang.String parameterName,
                              java.sql.Date x,
                              java.util.Calendar cal)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setDate` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
        `cal` - the `Calendar` object the driver will use to construct the date
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getDate(int)`

    - #### setTime

          public void setTime(java.lang.String parameterName,
                              java.sql.Time x,
                              java.util.Calendar cal)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setTime` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
        `cal` - the `Calendar` object the driver will use to construct the time
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getTime(int)`

    - #### setTimestamp

          public void setTimestamp(java.lang.String parameterName,
                                   java.sql.Timestamp x,
                                   java.util.Calendar cal)
                            throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setTimestamp` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
        `cal` - the `Calendar` object the driver will use to construct the timestamp
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `getTimestamp(int)`

    - #### setNull

          public void setNull(java.lang.String parameterName,
                              int sqlType,
                              java.lang.String typeName)
                       throws java.sql.SQLException

      Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

      Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it. Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setNull` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `sqlType` - a value from `java.sql.Types`
        `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or SQL `REF` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### getString

          public java.lang.String getString(java.lang.String parameterName)
                                     throws java.sql.SQLException

      Retrieves the value of a JDBC `CHAR`, `VARCHAR`, or `LONGVARCHAR` parameter as a `String` in the Java programming language.

      For the fixed-length type JDBC `CHAR`, the `String` object returned has exactly the same value the (JDBC4 clarification:) SQL `CHAR` value had in the database, including any padding added by the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getString` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setString(java.lang.String, java.lang.String)`

    - #### getBoolean

          public boolean getBoolean(java.lang.String parameterName)
                             throws java.sql.SQLException

      (JDBC4 modified:)

      Retrieves the value of a JDBC `BIT` or `BOOLEAN` parameter as a `boolean` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBoolean` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `false`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setBoolean(java.lang.String, boolean)`

    - #### getByte

          public byte getByte(java.lang.String parameterName)
                       throws java.sql.SQLException

      Retrieves the value of a JDBC `TINYINT` parameter as a `byte` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getByte` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setByte(java.lang.String, byte)`

    - #### getShort

          public short getShort(java.lang.String parameterName)
                         throws java.sql.SQLException

      Retrieves the value of a JDBC `SMALLINT` parameter as a `short` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getShort` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setShort(java.lang.String, short)`

    - #### getInt

          public int getInt(java.lang.String parameterName)
                     throws java.sql.SQLException

      Retrieves the value of a JDBC `INTEGER` parameter as an `int` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getInt` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setInt(java.lang.String, int)`

    - #### getLong

          public long getLong(java.lang.String parameterName)
                       throws java.sql.SQLException

      Retrieves the value of a JDBC `BIGINT` parameter as a `long` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getLong` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setLong(java.lang.String, long)`

    - #### getFloat

          public float getFloat(java.lang.String parameterName)
                         throws java.sql.SQLException

      Retrieves the value of a JDBC `FLOAT` parameter as a `float` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getFloat` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setFloat(java.lang.String, float)`

    - #### getDouble

          public double getDouble(java.lang.String parameterName)
                           throws java.sql.SQLException

      Retrieves the value of a JDBC `DOUBLE` parameter as a `double` in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getDouble` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `0`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setDouble(java.lang.String, double)`

    - #### getBytes

          public byte[] getBytes(java.lang.String parameterName)
                          throws java.sql.SQLException

      Retrieves the value of a JDBC `BINARY` or `VARBINARY` parameter as an array of `byte` values in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBytes` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setBytes(java.lang.String, byte[])`

    - #### getDate

          public java.sql.Date getDate(java.lang.String parameterName)
                                throws java.sql.SQLException

      Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getDate` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setDate(java.lang.String, java.sql.Date)`

    - #### getTime

          public java.sql.Time getTime(java.lang.String parameterName)
                                throws java.sql.SQLException

      Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTime` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setTime(java.lang.String, java.sql.Time)`

    - #### getTimestamp

          public java.sql.Timestamp getTimestamp(java.lang.String parameterName)
                                          throws java.sql.SQLException

      Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTimestamp` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setTimestamp(java.lang.String, java.sql.Timestamp)`

    - #### getObject

          public java.lang.Object getObject(java.lang.String parameterName)
                                     throws java.sql.SQLException

      Retrieves the value of a parameter as an `Object` in the Java programming language. If the value is an SQL `NULL`, the driver returns a Java `null`.

      This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        A `java.lang.Object` holding the OUT parameter value.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `Types`, `setObject(java.lang.String, java.lang.Object, int, int)`

    - #### getBigDecimal

          public java.math.BigDecimal getBigDecimal(java.lang.String parameterName)
                                             throws java.sql.SQLException

      Retrieves the value of a JDBC `NUMERIC` parameter as a `java.math.BigDecimal` object with as many digits to the right of the decimal point as the value contains.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBigDecimal` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value in full precision. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setBigDecimal(java.lang.String, java.math.BigDecimal)`

    - #### getObject

          public java.lang.Object getObject(java.lang.String parameterName,
                                            java.util.Map<java.lang.String,java.lang.Class<?>> map)
                                     throws java.sql.SQLException

      Returns an object representing the value of OUT parameter `parameterName` and uses `map` for the custom mapping of the parameter value.

      This method returns a Java object whose type corresponds to the JDBC type that was registered for this parameter using the method `registerOutParameter`. By registering the target JDBC type as `java.sql.Types.OTHER`, this method can be used to read database-specific abstract data types.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `map` - the mapping from SQL type names to Java classes
      Returns:
        a `java.lang.Object` holding the OUT parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setObject(java.lang.String, java.lang.Object, int, int)`

    - #### getRef

          public java.sql.Ref getRef(java.lang.String parameterName)
                              throws java.sql.SQLException

      Retrieves the value of a JDBC `REF(<structured-type>)` parameter as a `Ref` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getRef` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value as a `Ref` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### getBlob

          public java.sql.Blob getBlob(java.lang.String parameterName)
                                throws java.sql.SQLException

      Retrieves the value of a JDBC `BLOB` parameter as a `Blob` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getBlob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value as a `Blob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### getClob

          public java.sql.Clob getClob(java.lang.String parameterName)
                                throws java.sql.SQLException

      Retrieves the value of a JDBC `CLOB` parameter as a `Clob` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value as a `Clob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### getArray

          public java.sql.Array getArray(java.lang.String parameterName)
                                  throws java.sql.SQLException

      Retrieves the value of a JDBC `ARRAY` parameter as an `Array` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getArray` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value as an `Array` object in Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0

    - #### getDate

          public java.sql.Date getDate(java.lang.String parameterName,
                                       java.util.Calendar cal)
                                throws java.sql.SQLException

      Retrieves the value of a JDBC `DATE` parameter as a `java.sql.Date` object, using the given `Calendar` object to construct the date. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getDate` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `cal` - the `Calendar` object the driver will use to construct the date
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setDate(java.lang.String, java.sql.Date)`

    - #### getTime

          public java.sql.Time getTime(java.lang.String parameterName,
                                       java.util.Calendar cal)
                                throws java.sql.SQLException

      Retrieves the value of a JDBC `TIME` parameter as a `java.sql.Time` object, using the given `Calendar` object to construct the time. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTime` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `cal` - the `Calendar` object the driver will use to construct the time
      Returns:
        the parameter value; if the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setTime(java.lang.String, java.sql.Time)`

    - #### getTimestamp

          public java.sql.Timestamp getTimestamp(java.lang.String parameterName,
                                                 java.util.Calendar cal)
                                          throws java.sql.SQLException

      Retrieves the value of a JDBC `TIMESTAMP` parameter as a `java.sql.Timestamp` object, using the given `Calendar` object to construct the `Timestamp` object. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone and locale. If no `Calendar` object is specified, the driver uses the default timezone and locale.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getTimestamp` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `cal` - the `Calendar` object the driver will use to construct the timestamp
      Returns:
        the parameter value. If the value is SQL `NULL`, the result is `null`.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setTimestamp(java.lang.String, java.sql.Timestamp)`

    - #### getURL

          public java.net.URL getURL(java.lang.String parameterName)
                              throws java.sql.SQLException

      Retrieves the value of a JDBC `DATALINK` parameter as a `java.net.URL` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getURL` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value as a `java.net.URL` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs, this method is called on a closed `CallableStatement`, or if there is a problem with the URL
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.4, HSQLDB 1.7.0
      See Also:
        `setURL(java.lang.String, java.net.URL)`

    - #### getRowId

          public java.sql.RowId getRowId(int parameterIndex)
                                  throws java.sql.SQLException

      Retrieves the value of the designated JDBC `ROWID` parameter as a `java.sql.RowId` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getRowId` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2,...
      Returns:
        a `RowId` object that represents the JDBC `ROWID` value is used as the designated parameter. If the parameter contains a SQL `NULL`, then a `null` value is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[ if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getRowId

          public java.sql.RowId getRowId(java.lang.String parameterName)
                                  throws java.sql.SQLException

      Retrieves the value of the designated JDBC `ROWID` parameter as a `java.sql.RowId` object.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getRowId` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        a `RowId` object that represents the JDBC `ROWID` value is used as the designated parameter. If the parameter contains a SQL `NULL`, then a `null` value is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setRowId

          public void setRowId(java.lang.String parameterName,
                               java.sql.RowId x)
                        throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.RowId` object. The driver converts this to a SQL `ROWID` when it sends it to the database.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `setRowId` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNString

          public void setNString(java.lang.String parameterName,
                                 java.lang.String value)
                          throws java.sql.SQLException

      Sets the designated parameter to the given `String` object. The driver converts this to a SQL `NCHAR` or `NVARCHAR` or `LONGNVARCHAR`
      Specified by:
        `setNString` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter to be set
        `value` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNCharacterStream

          public void setNCharacterStream(java.lang.String parameterName,
                                          java.io.Reader value,
                                          long length)
                                   throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.
      Specified by:
        `setNCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter to be set
        `value` - the parameter value
        `length` - the number of characters in the parameter data.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNClob

          public void setNClob(java.lang.String parameterName,
                               java.sql.NClob value)
                        throws java.sql.SQLException

      Sets the designated parameter to a `java.sql.NClob` object. The object implements the `java.sql.NClob` interface. This `NClob` object maps to a SQL `NCLOB`.
      Specified by:
        `setNClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter to be set
        `value` - the parameter value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setClob

          public void setClob(java.lang.String parameterName,
                              java.io.Reader reader,
                              long length)
                       throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The `reader` must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `CallableStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGVARCHAR` or a `CLOB`
      Specified by:
        `setClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter to be set
        `reader` - An object that contains the data to set the parameter value to.
        `length` - the number of characters in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if the length specified is less than zero; a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setBlob

          public void setBlob(java.lang.String parameterName,
                              java.io.InputStream inputStream,
                              long length)
                       throws java.sql.SQLException

      Sets the designated parameter to a `InputStream` object. The `inputstream` must contain the number of characters specified by length, otherwise a `SQLException` will be generated when the `CallableStatement` is executed. This method differs from the `setBinaryStream (int, InputStream, int)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`
      Specified by:
        `setBlob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter to be set the second is 2, ...
        `inputStream` - An object that contains the data to set the parameter value to.
        `length` - the number of bytes in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if the length specified is less than zero; if the number of bytes in the input stream does not match the specified length; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setNClob

          public void setNClob(java.lang.String parameterName,
                               java.io.Reader reader,
                               long length)
                        throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The `reader` must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `CallableStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGNVARCHAR` or a `NCLOB`
      Specified by:
        `setNClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter to be set
        `reader` - An object that contains the data to set the parameter value to.
        `length` - the number of characters in the parameter data.
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if the length specified is less than zero; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getNClob

          public java.sql.NClob getNClob(int parameterIndex)
                                  throws java.sql.SQLException

      Retrieves the value of the designated JDBC `NCLOB` parameter as a `java.sql.NClob` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getNClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
      Returns:
        the parameter value as a `NClob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getNClob

          public java.sql.NClob getNClob(java.lang.String parameterName)
                                  throws java.sql.SQLException

      Retrieves the value of a JDBC `NCLOB` parameter as a `java.sql.NClob` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getNClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        the parameter value as a `NClob` object in the Java programming language. If the value was SQL `NULL`, the value `null` is returned.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setSQLXML

          public void setSQLXML(java.lang.String parameterName,
                                java.sql.SQLXML xmlObject)
                         throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.SQLXML` object. The driver converts this to an `SQL XML` value when it sends it to the database.
      Specified by:
        `setSQLXML` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `xmlObject` - a `SQLXML` object that maps an `SQL XML` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs; this method is called on a closed `CallableStatement` or the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getSQLXML

          public java.sql.SQLXML getSQLXML(int parameterIndex)
                                    throws java.sql.SQLException

      Retrieves the value of the designated `SQL XML` parameter as a `java.sql.SQLXML` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getSQLXML` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
      Returns:
        a `SQLXML` object that maps an `SQL XML` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getSQLXML

          public java.sql.SQLXML getSQLXML(java.lang.String parameterName)
                                    throws java.sql.SQLException

      Retrieves the value of the designated `SQL XML` parameter as a `java.sql.SQLXML` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getSQLXML` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        a `SQLXML` object that maps an `SQL XML` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getNString

          public java.lang.String getNString(int parameterIndex)
                                      throws java.sql.SQLException

      Retrieves the value of the designated `NCHAR`, `NVARCHAR` or `LONGNVARCHAR` parameter as a `String` in the Java programming language.

      For the fixed-length type JDBC `NCHAR`, the `String` object returned has exactly the same value the SQL `NCHAR` value had in the database, including any padding added by the database.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getNString` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - index of the first parameter is 1, the second is 2, ...
      Returns:
        a `String` object that maps an `NCHAR`, `NVARCHAR` or `LONGNVARCHAR` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0
      See Also:
        `setNString(java.lang.String, java.lang.String)`

    - #### getNString

          public java.lang.String getNString(java.lang.String parameterName)
                                      throws java.sql.SQLException

      Retrieves the value of the designated `NCHAR`, `NVARCHAR` or `LONGNVARCHAR` parameter as a `String` in the Java programming language.

      For the fixed-length type JDBC `NCHAR`, the `String` object returned has exactly the same value the SQL `NCHAR` value had in the database, including any padding added by the database.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getNString` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        a `String` object that maps an `NCHAR`, `NVARCHAR` or `LONGNVARCHAR` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0
      See Also:
        `setNString(java.lang.String, java.lang.String)`

    - #### getNCharacterStream

          public java.io.Reader getNCharacterStream(int parameterIndex)
                                             throws java.sql.SQLException

      Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language. It is intended for use when accessing `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` parameters.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getNCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
      Returns:
        a `java.io.Reader` object that contains the parameter value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getNCharacterStream

          public java.io.Reader getNCharacterStream(java.lang.String parameterName)
                                             throws java.sql.SQLException

      Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language. It is intended for use when accessing `NCHAR`,`NVARCHAR` and `LONGNVARCHAR` parameters.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getNCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        a `java.io.Reader` object that contains the parameter value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getCharacterStream

          public java.io.Reader getCharacterStream(int parameterIndex)
                                            throws java.sql.SQLException

      Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB does not yet support this feature.

      Calling this method always throws an `SQLException`.

      Specified by:
        `getCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, ...
      Returns:
        a `java.io.Reader` object that contains the parameter value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language.
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if the parameterIndex is not valid;] if a database access error occurs or this method is called on a closed `CallableStatement`
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### getCharacterStream

          public java.io.Reader getCharacterStream(java.lang.String parameterName)
                                            throws java.sql.SQLException

      Retrieves the value of the designated parameter as a `java.io.Reader` object in the Java programming language.

      ### HSQLDB-Specific Information:

      HSQLDB supports this feature.

      Specified by:
        `getCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
      Returns:
        a `java.io.Reader` object that contains the parameter value; if the value is SQL `NULL`, the value returned is `null` in the Java programming language
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setBlob

          public void setBlob(java.lang.String parameterName,
                              java.sql.Blob x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.
      Specified by:
        `setBlob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - a `Blob` object that maps an SQL `BLOB` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setClob

          public void setClob(java.lang.String parameterName,
                              java.sql.Clob x)
                       throws java.sql.SQLException

      Sets the designated parameter to the given `java.sql.Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.
      Specified by:
        `setClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - a `Clob` object that maps an SQL `CLOB` value
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setAsciiStream

          public void setAsciiStream(java.lang.String parameterName,
                                     java.io.InputStream x,
                                     long length)
                              throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Specified by:
        `setAsciiStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the Java input stream that contains the ASCII parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setBinaryStream

          public void setBinaryStream(java.lang.String parameterName,
                                      java.io.InputStream x,
                                      long length)
                               throws java.sql.SQLException

      Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Specified by:
        `setBinaryStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the java input stream which contains the binary parameter value
        `length` - the number of bytes in the stream
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setCharacterStream

          public void setCharacterStream(java.lang.String parameterName,
                                         java.io.Reader reader,
                                         long length)
                                  throws java.sql.SQLException

      Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Specified by:
        `setCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `reader` - the `java.io.Reader` object that contains the UNICODE data used as the designated parameter
        `length` - the number of characters in the stream
      Throws:
        `java.sql.SQLException` - JDBC 4.1[if parameterName does not correspond to a named parameter;] if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setAsciiStream

          public void setAsciiStream(java.lang.String parameterName,
                                     java.io.InputStream x)
                              throws java.sql.SQLException

      Sets the designated parameter to the given input stream. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setAsciiStream` which takes a length parameter.

      Specified by:
        `setAsciiStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the Java input stream that contains the ASCII parameter value
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setBinaryStream

          public void setBinaryStream(java.lang.String parameterName,
                                      java.io.InputStream x)
                               throws java.sql.SQLException

      Sets the designated parameter to the given input stream. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBinaryStream` which takes a length parameter.

      Specified by:
        `setBinaryStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `x` - the java input stream which contains the binary parameter value
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.6, HSQLDB 2.0

    - #### setCharacterStream

          public void setCharacterStream(java.lang.String parameterName,
                                         java.io.Reader reader)
                                  throws java.sql.SQLException

      Sets the designated parameter to the given `Reader` object. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setCharacterStream` which takes a length parameter.

      Specified by:
        `setCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `reader` - the `java.io.Reader` object that contains the Unicode data
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method JDK 1.6, HSQLDB 2.0

    - #### setNCharacterStream

          public void setNCharacterStream(java.lang.String parameterName,
                                          java.io.Reader value)
                                   throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

      Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNCharacterStream` which takes a length parameter.

      Specified by:
        `setNCharacterStream` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `value` - the parameter value
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method JDK 1.6, HSQLDB 2.0

    - #### setClob

          public void setClob(java.lang.String parameterName,
                              java.io.Reader reader)
                       throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGVARCHAR` or a `CLOB`

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setClob` which takes a length parameter.

      Specified by:
        `setClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `reader` - An object that contains the data to set the parameter value to.
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method JDK 1.6, HSQLDB 2.0

    - #### setBlob

          public void setBlob(java.lang.String parameterName,
                              java.io.InputStream inputStream)
                       throws java.sql.SQLException

      Sets the designated parameter to a `InputStream` object. This method differs from the `setBinaryStream (int, InputStream)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGVARBINARY` or a `BLOB`

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBlob` which takes a length parameter.

      Specified by:
        `setBlob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `inputStream` - An object that contains the data to set the parameter value to.
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method JDK 1.6, HSQLDB 2.0

    - #### setNClob

          public void setNClob(java.lang.String parameterName,
                               java.io.Reader reader)
                        throws java.sql.SQLException

      Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be send to the server as a `LONGNVARCHAR` or a `NCLOB`

      Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNClob` which takes a length parameter.

      Specified by:
        `setNClob` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `reader` - An object that contains the data to set the parameter value to.
      Throws:
        `java.sql.SQLException` - if parameterName does not correspond to a named parameter; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `CallableStatement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method JDK 1.6, HSQLDB 2.0

    - #### getObject

          public <T> T getObject(int parameterIndex,
                                 java.lang.Class<T> type)
                          throws java.sql.SQLException

      Returns an object representing the value of OUT parameter `parameterIndex` and will convert from the SQL type of the parameter to the requested Java data type, if the conversion is supported. If the conversion is not supported or null is specified for the type, a `SQLException` is thrown.

      At a minimum, an implementation must support the conversions defined in Appendix B, Table B-3 and conversion of appropriate user defined SQL types to a Java type which implements `SQLData`, or `Struct`. Additional conversions may be supported and are vendor defined.

      Specified by:
        `getObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterIndex` - the first parameter is 1, the second is 2, and so on
        `type` - Class representing the Java data type to convert the designated parameter to.
      Returns:
        an instance of `type` holding the OUT parameter value
      Throws:
        `java.sql.SQLException` - if conversion is not supported, type is null or another error occurs. The getCause() method of the exception may provide a more detailed exception, for example, if a conversion error occurs
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1

    - #### getObject

          public <T> T getObject(java.lang.String parameterName,
                                 java.lang.Class<T> type)
                          throws java.sql.SQLException

      Returns an object representing the value of OUT parameter `parameterName` and will convert from the SQL type of the parameter to the requested Java data type, if the conversion is supported. If the conversion is not supported or null is specified for the type, a `SQLException` is thrown.

      At a minimum, an implementation must support the conversions defined in Appendix B, Table B-3 and conversion of appropriate user defined SQL types to a Java type which implements `SQLData`, or `Struct`. Additional conversions may be supported and are vendor defined.

      Specified by:
        `getObject` in interface `java.sql.CallableStatement`
      Parameters:
        `parameterName` - the name of the parameter
        `type` - Class representing the Java data type to convert the designated parameter to.
      Returns:
        an instance of `type` holding the OUT parameter value
      Throws:
        `java.sql.SQLException` - if conversion is not supported, type is null or another error occurs. The getCause() method of the exception may provide a more detailed exception, for example, if a conversion error occurs
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.0.1

    - #### close

          public void close()
                     throws java.sql.SQLException

      Does the specialized work required to free this object's resources and that of it's parent classes.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.sql.Statement`
      Overrides:
        `close` in class `JDBCPreparedStatement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### closeOnCompletion

          public void closeOnCompletion()
                                 throws java.sql.SQLException

      Specifies that this `Statement` will be closed when all its dependent result sets are closed. If execution of the `Statement` does not produce any result sets, this method has no effect.

      Note: Multiple calls to `closeOnCompletion` do not toggle the effect on this `Statement`. However, a call to `closeOnCompletion` does effect both the subsequent execution of statements, and statements that currently have open, dependent, result sets.

      Specified by:
        `closeOnCompletion` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`

    - #### isCloseOnCompletion

          public boolean isCloseOnCompletion()
                                      throws java.sql.SQLException

      Returns a value indicating whether this `Statement` will be closed when all its dependent result sets are closed.
      Specified by:
        `isCloseOnCompletion` in interface `java.sql.Statement`
      Returns:
        `true` if the `Statement` will be closed when all of its dependent result sets are closed; `false` otherwise
      Throws:
        `java.sql.SQLException` - if this method is called on a closed `Statement`

    - #### executeQuery

          public java.sql.ResultSet executeQuery()
                                          throws java.sql.SQLException

      Executes the SQL query in this `PreparedStatement` object and returns the `ResultSet` object generated by the query.

      ### HSQLDB-Specific Information:

      HSQLDB supports this method for a call to a FUNCTION that returns a result. For a PROCEDURE that returns one or more results, the first result is returned.

      If the FUNCTION or PROCEDURE does not return a ResultSet, an `SQLException` is thrown.

      Specified by:
        `executeQuery` in interface `java.sql.PreparedStatement`
      Overrides:
        `executeQuery` in class `JDBCPreparedStatement`
      Returns:
        a `ResultSet` object that contains the data produced by the query; never `null`
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `PreparedStatement` or the SQL statement does not return a `ResultSet` object

Copyright © 2001 - 2018 HSQL Development Group.